# Author: Dgass  Blog: https://dangasdiy.top/
# inspiration l298n_lib.py from peppe8o  Blog: https://peppe8o.com
# Date: Nov 21th, 2024
from machine import Pin, PWM, I2C, ADC
import network
import socket
import math
from time import sleep
#from pico_i2c_lcd import I2cLcd
# onboard pin
global cl, trace, lineco
led = Pin("LED", Pin.OUT)
lineco = 1
# wifi
ssid = 'ORBI92'
password = 'vastcartoon938'
html1 = """<html>
<meta charset="utf-8">
<style>
.web-safe {
font-family: "Courier New", Courier, monospace;
font-size: 1em;
line-height: 0.05em;
}
</style>
<div class='web-safe'><p><h3>%s</h3></p></div>
</html>"""
trace = 1
if trace == 1 :
    wlan = network.WLAN(network.STA_IF)
    wlan.active(True)
    wlan.connect(ssid, password)   
    max_wait = 10    
    while max_wait > 0:
        if wlan.status() < 0 or wlan.status() >= 3:
            break
        max_wait -= 1
        print('waiting for connection...')
        sleep(1)

    if wlan.status() != 3:
        for i in range (1, 100, 1) :
            led.toggle()
            sleep(0.5)
        raise RuntimeError('network connection failed')
    else:
        print('connected')
        status = wlan.ifconfig()
        print( 'ip = ' + status[0] )

    addr = socket.getaddrinfo(status[0], 80)[0][-1]
    s = socket.socket()
    s.bind(addr)
    s.listen(1)    
    print('listening on', addr)
    global cl
    led.value(1)
    cl, addr = s.accept()
    led.value(0)  
def sendmsg(txt) :
    global cl, lineco
    txt = str(lineco) + " " + txt; lineco += 1;    
    print(txt)
    if trace == 0 : return
    response = html1 % txt
    cl.send(response)
# IR sensor
irlect = ADC(26)       # IR sensor

# relationship between hight and servo angl (after manual measurement)
tabh0 = (90, 90, 90, 90, 0)
tabh1 = (126, 72, 62, 112, 0) # 10cm
tabh2 = (132, 66, 60, 112, 0) # 8.26 cm
tabh3 = (140, 56, 52, 110, 0) # 6.35cm
def IR_read():   
    laser_value = round(irlect.read_u16()/1500,2)
    # conversion IR value in cm or to inch by dividing by 2.54
    dist=round(0.0103397*laser_value*laser_value-0.811132*laser_value+20.5,2)
    ret = tabh0
    if dist < 11   : ret = tabh1
    if dist < 8.26 : ret = tabh2
    if dist < 6.65 : ret = tabh3
    l = list(ret)
    l[4] =  dist
    return(l)
#
# motors (inspiration from peppe8o)
#
class L293D_motor:  # inspiration l298n_lib.py from peppe8o
    def __init__(self, EN1, IN1_1,EN2, IN2_1, loc):
        self.ENA = PWM(Pin(EN1))
        self.IN1_1 = Pin(IN1_1, mode=Pin.OUT)      
        self.ENB = PWM(Pin(EN2))
        self.IN2_1 = Pin(IN2_1, mode=Pin.OUT)       
        self.speed = 0
        self.loc = loc

    def setSpeed(self, speed_1, speed_2):
        self.ENA.freq(50)
        self.ENB.freq(50)
        speed_1 = min(100, max(-100, speed_1))
        speed_2 = min(100, max(-100, speed_2))
        if speed_1 < 0:
            self.IN1_1.value(0)
        elif speed_1 > 0:
            self.IN1_1.value(1)
        
        if speed_2 > 0:
            self.IN2_1.value(0)
        elif speed_2 < 0:
            self.IN2_1.value(1)

        self.ENA.duty_u16(int(math.fabs(speed_1)/100*65536))
        self.ENB.duty_u16(int(math.fabs(speed_2)/100*65536))

        if speed_1 != 0 :
            buf = self.loc + " motor speed " + str(speed_1) + " " + str(speed_2)
            sendmsg(buf)
        
    def close(self):
        self.ENA.deinit()
        self.ENB.deinit()
#
# servo control (addon DGass)
#
def conv_puls (angl):
  return (angl*36+1700)

class servo :  # to control two servos simultaneously
    def __init__(self, left, lrest, lmin, lmax, right, rrest, rmin, rmax, loc):
        self.lf = PWM(left)
        self.lf.freq(50)
        self.loc = loc
        self.pos_rest_left      = lrest
        self.pos_act_left  = self.pos_rest_left
        self.pos_rest_left_min  = lmin
        self.pos_rest_left_max  = lmax

        self.rf = PWM(right)
        self.rf.freq(50)
        self.pos_rest_right     = rrest
        self.pos_act_right = self.pos_rest_right
        self.pos_rest_right_min = rmin
        self.pos_rest_right_max = rmax
        
    def move(self, val):
        self.pos_act_left = self.pos_act_left + val
        if self.pos_act_left < self.pos_rest_left_min : self.pos_act_left = self.pos_rest_left_min
        if self.pos_act_left > self.pos_rest_left_max : self.pos_act_left = self.pos_rest_left_max
        self.lf.duty_u16(conv_puls(self.pos_act_left))
        
        self.pos_act_right = self.pos_act_right - val
        if self.pos_act_right < self.pos_rest_right_min : self.pos_act_right = self.pos_rest_right_min
        if self.pos_act_right > self.pos_rest_right_max : self.pos_act_right = self.pos_rest_right_max
        self.rf.duty_u16(conv_puls(self.pos_act_right))
        
        buf = self.loc + " servos position " + str(self.pos_act_left) + " " + str(self.pos_act_right) + "   "
        sendmsg(buf)
        
    def close(self): # Slowly put to rest      
        vleft = -2
        vright = 2
        if self.pos_act_left  < self.pos_rest_left : vleft = 2 ; vright = -2

        for self.pos_act_left in range (self.pos_act_left,   self.pos_rest_left, vleft):          
            self.lf.duty_u16(conv_puls(self.pos_act_left))       
            self.rf.duty_u16(conv_puls(self.pos_act_right))
            self.pos_act_right = self.pos_act_right + vright
            sleep(0.1)
        self.pos_act_left  = self.pos_rest_left
        self.pos_act_right = self.pos_rest_right
        self.lf.duty_u16(conv_puls(self.pos_rest_left))
        self.rf.duty_u16(conv_puls(self.pos_rest_right))
        
        buf = self.loc + " servos position " + str(self.pos_act_left) + " " + str(self.pos_act_right) + "   "
        sendmsg(buf)
 
